// Funciona

 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

// Frog

 public class Frog extends NslModule /*(int wx,int wz,int recsize,int tectsize,int tx,int ty,int rrf)*/ 
{
	public NslDinDouble2 worldXZ ; /*(wx,wz)*/  
	public NslDoutDouble0 xf ; /*()*/
	public NslDoutDouble0 yf ; /*()*/
	public NslDoutDouble0 zf ; /*()*/	
	public NslDinDouble0 xw ; /*()*/
	public NslDinDouble0 yw ; /*()*/
	public NslDinDouble0 zw ; /*()*/	
	public NslDinDouble0 xb_init ; /*()*/
	public NslDinDouble0 xb_end ; /*()*/
	public NslDinDouble0 yb ; /*()*/
	public NslDinDouble0 zb ; /*()*/
	
	public NslDoutDouble0 forward_step ; /*()*/
	public NslDoutDouble0 backward_step ; /*()*/
	public NslDoutDouble0 wangle ; /*()*/
	public NslDoutDouble0 angle ; /*()*/

	private VisualField visual ; /*(wx,wz,recsize)*/
	private Depth depth ; /*()*/
	private Tactile tactile ; /*()*/
	private PreyRec preyRec ; /*(recsize,tx,ty)*/
	private SorRec sorRec ; /*(recsize,tx,ty)*/
	private PreyApproach preyApproach ; /*(tx,ty)*/
	private SorAvoid sorAvoid ; /*(tectsize,tx,ty,rrf)*/
	private BumpAvoid bumpAvoid ; /*(tectsize)*/
	private MHM mhm ; /*(tectsize)*/
	private WTA wta ; /*(tectsize)*/
	private Xform xform ; /*(tectsize)*/
	private Forward forward ; /*()*/
	private Sidestep sidestep ; /*()*/
	private Backward backward ; /*()*/
			
	private NslDouble0 safeDistance ; /*()*/
        
        //VISUALIZATION by rodolfo
        private FieldsOutput fields;
        public NslDinDouble0 bump;
               
        
	public void makeConn()
	{
		nslConnect (worldXZ,visual.worldXZ);
		nslConnect (xb_init,depth.xb_init);
		nslConnect (xb_end,depth.xb_end);
		nslConnect (yb,depth.yb);
		nslConnect (sidestep.out,angle);
		nslConnect (forward.out,forward_step); //by rodolfo
		nslConnect (backward.out,backward_step);
		nslConnect (xw,depth.xw);	
		nslConnect (yw,depth.yw);

		nslConnect (xf,visual.xf);
		nslConnect (zf,visual.zf);
		nslConnect (xf,depth.xf);	
		nslConnect (yf,depth.yf);
	
		nslConnect (visual.visualField,preyRec.visualField);
		nslConnect (visual.visualField,sorRec.visualField);
		nslConnect (depth.ps,forward.psdp);	
		nslConnect (depth.depthY,tactile.depthY);
		nslConnect (depth.depthX,tactile.depthX);
		nslConnect (depth.depthY,sorRec.depthY);
		nslConnect (depth.depthX,sorRec.depthX);
		nslConnect (depth.depthY,bumpAvoid.depthY);
		nslConnect (depth.depthX,bumpAvoid.depthX);
		nslConnect (depth.depthY,forward.depthY);
		nslConnect (tactile.ps,bumpAvoid.psta);	
		nslConnect (tactile.ps,forward.psta);	
		nslConnect (tactile.ps,sidestep.psta);	
		nslConnect (tactile.ps,backward.psta);	
		nslConnect (preyRec.t5_2f,preyApproach.t5_2f);
		nslConnect (preyRec.ps,preyApproach.psfo);		
		nslConnect (preyRec.ps,forward.psfo);	
		nslConnect (sorRec.th10f,sorAvoid.th10f);
		nslConnect (sorRec.ps,sorAvoid.psso);	
		nslConnect (sorRec.ps,sidestep.psso);
		nslConnect (preyApproach.preyHor_f,mhm.preyHorF);		
		nslConnect (preyApproach.ps,mhm.pspa);	
		nslConnect (preyApproach.ps,xform.pspa);	
		nslConnect (sorAvoid.gapsf,bumpAvoid.gaps);		
		nslConnect (sorAvoid.ps,mhm.psoa);	
		nslConnect (sorAvoid.ps,xform.psoa);	
		nslConnect (bumpAvoid.baf,mhm.baf);		
		nslConnect (bumpAvoid.ps,sidestep.psba);	
		nslConnect (bumpAvoid.ps,backward.psba);	
		nslConnect (bumpAvoid.gapsf,mhm.gapsf);		
		nslConnect (mhm.ps,forward.psmhm);	
		nslConnect (mhm.ps,sidestep.psmhm);	
		nslConnect (mhm.mhm,wta.mhm);	
		nslConnect (wta.wta_mhm,xform.wta_mhm);	
		nslConnect (xform.angle,sidestep.angle);	
		nslConnect (xform.ps,sidestep.psx);	
		nslConnect (forward.ps,backward.psfw);	
		nslConnect (backward.ps,forward.psbk);	
                
                //Visualization by rodolfo
                nslConnect (preyApproach.preyHor_f, fields.preyHor);
                nslConnect (sorAvoid.gapsf, fields.gaps);
                nslConnect (bumpAvoid.baf, fields.baf);
                nslConnect (mhm.mhm, fields.mhm);
                nslConnect (wta.wta_mhm, fields.wta_mhm);
                
                //bump mod
                nslConnect (bump, tactile.bump);
	}

	public  void endRun()
	{
		 double pi = 3.1415926535;
		 double iangle = 0;

		 double x0 = xf.getdouble() - xb_init.getdouble();
		 double x2 = xb_end.getdouble() - xf.getdouble();
		 double yd = yf.getdouble() - yb.getdouble();

		 double x1 = xf.getdouble() - xw.getdouble();
		 double y1 = yf.getdouble() - yw.getdouble();

		 double xd = angle.getdouble() - yd*x1/y1; 
		
		/* verbatim NSLJ */
  		double t = NslOperator.atan.eval(xd/yd);
  		 /* verbatim off */
		 double disp = forward_step.getdouble() - backward_step.getdouble(); // overall displacement		
		/* verbatim NSLJ */
  		double dispx = NslOperator.abs.eval(disp)*NslOperator.sin.eval(t);
  		 /* verbatim off */		
		
		/* verbatim NSLJ */
  		double dispy = disp*NslOperator.cos.eval(t);
  		 /* verbatim off */		
		 double dispx0 = dispx;
		 double dispy0 = dispy;

		if ((((
 nslj.src.math.NslGtr.eval(yf.get(),yb.get()))&&(((yf.getdouble())-(dispy))<(
 nslj.src.math.NslAdd.eval(yb.get(),safeDistance.get()))))&&(((xf.getdouble())+(dispx))>(
 nslj.src.math.NslSub.eval(xb_init.get(),safeDistance.get()))))&&(((xf.getdouble())+(dispx))<(
 nslj.src.math.NslAdd.eval(xb_end.get(),safeDistance.get())))) 
		{
			dispy=((yf.getdouble())-(yb.getdouble()))-((safeDistance).getdouble())/* rule 202*/; // maximum movement
			dispx = dispx0*dispy/dispy0;
		}

		yf.set((yf.getdouble())-(dispy));

		if ((
 nslj.src.math.NslGeq.eval(yf.get(),
 nslj.src.math.NslSub.eval(yb.get(),safeDistance.get())))&&(
 nslj.src.math.NslLeq.eval(yf.get(),
 nslj.src.math.NslAdd.eval(yb.get(),safeDistance.get()))))
		{
			if ((((xf.getdouble())+(dispx))<(xb_init.getdouble()))&&(((xf.getdouble())+(dispx))>(
 nslj.src.math.NslSub.eval(xb_init.get(),safeDistance.get()))))
				dispx = xb_init.getdouble() - xf.getdouble() - safeDistance.getdouble(); // maximum movement
			else if ((((xf.getdouble())+(dispx))>(xb_end.getdouble()))&&(((xf.getdouble())+(dispx))<(
 nslj.src.math.NslAdd.eval(xb_end.get(),safeDistance.get()))))
				dispx=((xf.getdouble())-(xb_end.getdouble()))+((safeDistance).getdouble())/* rule 202*/; // maximum movement
		}

		xf.set((xf.getdouble())+(dispx)); 

		if (
 nslj.src.math.NslLeq.eval(yf.get(),yw.get()))
		{
			System.out.println("Ate Worm");
			yf.set(yw);
			xf.set(xw); 

			//system.breakEpoch();
			return;
		}

		 double x = 0, y = 0;

		x = xf.getdouble() - xw.getdouble();
		y = yf.getdouble() - yw.getdouble();

		if (y != 0) 
		{
			/* verbatim NSLJ */
  			iangle = NslOperator.atan.eval(x/y);
  			 /* verbatim off */		
			wangle.set(((iangle)*(180))/(pi));
		}
		else 
		{
			iangle = pi/2;
			wangle.set(90);
		}
                
	}
	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	/* constructor and related methods */
	/* nsl declarations */
	int wx;
	int wz;
	int recsize;
	int tectsize;
	int tx;
	int ty;
	int rrf;

	 /*GENERIC CONSTRUCTOR:   */
	 public Frog(String nslName, NslModule nslParent,int wx, int wz, int recsize, int tectsize, int tx, int ty, int rrf) {
		super(nslName, nslParent);
		this.wx = wx;
		this.wz = wz;
		this.recsize = recsize;
		this.tectsize = tectsize;
		this.tx = tx;
		this.ty = ty;
		this.rrf = rrf;
		
                //by rodolfo 
                makeInst(nslName, nslParent,wx, wz, recsize, tectsize, tx, ty, rrf);
                initSys();
		
	}
	public void makeInst(String nslName, NslModule nslParent,int wx,int wz,int recsize,int tectsize,int tx,int ty,int rrf){ 
	 worldXZ=new NslDinDouble2 ("worldXZ",this,wx,wz); //NSLDECLS 
	 xf=new NslDoutDouble0 ("xf",this); //NSLDECLS 
	 yf=new NslDoutDouble0 ("yf",this); //NSLDECLS 
	 zf=new NslDoutDouble0 ("zf",this); //NSLDECLS 
	 xw=new NslDinDouble0 ("xw",this); //NSLDECLS 
	 yw=new NslDinDouble0 ("yw",this); //NSLDECLS 
	 zw=new NslDinDouble0 ("zw",this); //NSLDECLS 
	 xb_init=new NslDinDouble0 ("xb_init",this); //NSLDECLS 
	 xb_end=new NslDinDouble0 ("xb_end",this); //NSLDECLS 
	 yb=new NslDinDouble0 ("yb",this); //NSLDECLS 
	 zb=new NslDinDouble0 ("zb",this); //NSLDECLS 
	 forward_step=new NslDoutDouble0 ("forward_step",this); //NSLDECLS 
	 backward_step=new NslDoutDouble0 ("backward_step",this); //NSLDECLS 
	 wangle=new NslDoutDouble0 ("wangle",this); //NSLDECLS 
	 angle=new NslDoutDouble0 ("angle",this); //NSLDECLS 
	 visual=new VisualField ("visual",this,wx,wz,recsize); //NSLDECLS 
	 depth=new Depth ("depth",this); //NSLDECLS 
	 tactile=new Tactile ("tactile",this); //NSLDECLS 
	 preyRec=new PreyRec ("preyRec",this,recsize,tx,ty); //NSLDECLS 
	 sorRec=new SorRec ("sorRec",this,recsize,tx,ty); //NSLDECLS 
	 preyApproach=new PreyApproach ("preyApproach",this,tx,ty); //NSLDECLS 
	 sorAvoid=new SorAvoid ("sorAvoid",this,tectsize,tx,ty,rrf); //NSLDECLS 
	 bumpAvoid=new BumpAvoid ("bumpAvoid",this,tectsize); //NSLDECLS 
	 mhm=new MHM ("mhm",this,tectsize); //NSLDECLS 
	 wta=new WTA ("wta",this,tectsize); //NSLDECLS 
	 xform=new Xform ("xform",this,tectsize); //NSLDECLS 
	 forward=new Forward ("forward",this); //NSLDECLS 
	 sidestep=new Sidestep ("sidestep",this); //NSLDECLS 
	 backward=new Backward ("backward",this); //NSLDECLS 
	 safeDistance=new NslDouble0 ("safeDistance",this); //NSLDECLS 
         
         
         //Visualization by rodolfo
         fields = new FieldsOutput("FieldsOutput", this, tectsize);
         
         //bump by rodolfo
         bump = new NslDinDouble0("bump", this);
        
	}
	/* end of automatic declaration statements */
}
