package patch.src.util;
//
// Copyright (c) 1996 Dennis Heimbigner. email dennis@cs.colorado.edu

public
abstract
class YYtokentypes {

public static int YYEOF = 0;

public static final int tokenmin = 258;
public static final int tokenmax = 283;

public static final int ERROR = 258;
public static final int SYMBOL = 259;
public static final int FINAL = 260;
public static final int SYNCHRONIZED = 261;
public static final int PUBLIC = 262;
public static final int ABSTRACT = 263;
public static final int INTERFACE = 264;
public static final int IMPLEMENTS = 265;
public static final int EXTENDS = 266;
public static final int CLASS = 267;
public static final int PRIVATE = 268;
public static final int PROTECTED = 269;
public static final int STATIC = 270;
public static final int TRANSIENT = 271;
public static final int VOLATILE = 272;
public static final int NATIVE = 273;
public static final int BOOLEAN = 274;
public static final int BYTE = 275;
public static final int CHAR = 276;
public static final int DOUBLE = 277;
public static final int FLOAT = 278;
public static final int VOID = 279;
public static final int LONG = 280;
public static final int STRING = 281;
public static final int INT = 282;
public static final int SHORT = 283;


public static final String tokennames[] = {
"ERROR", "SYMBOL", "FINAL", "SYNCHRONIZED", "PUBLIC", "ABSTRACT", "INTERFACE", "IMPLEMENTS", "EXTENDS", "CLASS", "PRIVATE", "PROTECTED", "STATIC", "TRANSIENT", "VOLATILE", "NATIVE", "BOOLEAN", "BYTE", "CHAR", "DOUBLE", "FLOAT", "VOID", "LONG", "STRING", "INT", "SHORT", null
};

public static String tokenname(int t)
{
    if(t >= tokenmin && t <= tokenmax) {
	return tokennames[t - tokenmin];
    } else if(t > 0 && t <= 255) {
	return "'" + String.valueOf((char)t) + "'";
    } else if(t == YYEOF) {
	return "EOF";
    } else {
	return "$undefined$";
    }
}

//////////////////////////////////////////////////

public static final int nontermmin = 284;
public static final int nontermmax = 309;

public static final int nt_compilationUnit = 284;
public static final int nt_typeDeclaration = 285;
public static final int nt_classDeclaration = 286;
public static final int nt_interfaceDeclaration = 287;
public static final int nt_classDecl1 = 288;
public static final int nt_classDecl2 = 289;
public static final int nt_interfaceDecl1 = 290;
public static final int nt_interfaceDecl2 = 291;
public static final int nt_classModifierList = 292;
public static final int nt_interfaces = 293;
public static final int nt_qualifiedSymbol = 294;
public static final int nt_simpleSymbol = 295;
public static final int nt_classBlock = 296;
public static final int nt_fieldList = 297;
public static final int nt_field = 298;
public static final int nt_modifierList = 299;
public static final int nt_methodDeclaration = 300;
public static final int nt_method = 301;
public static final int nt_variableDeclaration = 302;
public static final int nt_variable = 303;
public static final int nt_simpleType = 304;
public static final int nt_optArgList = 305;
public static final int nt_argList = 306;
public static final int nt_arg = 307;
public static final int nt_optArrayBounds = 308;
public static final int nt_ignore = 309;


public static final String nontermnames[] = {
"compilationUnit", "typeDeclaration", "classDeclaration", "interfaceDeclaration", "classDecl1", "classDecl2", "interfaceDecl1", "interfaceDecl2", "classModifierList", "interfaces", "qualifiedSymbol", "simpleSymbol", "classBlock", "fieldList", "field", "modifierList", "methodDeclaration", "method", "variableDeclaration", "variable", "simpleType", "optArgList", "argList", "arg", "optArrayBounds", "ignore", null
};

public static String nontermname(int t)
{
    if(t >= nontermmin && t <= nontermmax) {
	return nontermnames[t - nontermmin];
    } else {
	return "$undefined$";
    }
}

};
