package npp.src.util;
//
// Copyright (c) 1996 Dennis Heimbigner. email dennis@cs.colorado.edu

public
abstract
class YYtokentypes {

public static int YYEOF = 0;

public static final int tokenmin = 258;
public static final int tokenmax = 355;

public static final int ERROR = 258;
public static final int ABSTRACT = 259;
public static final int BOOLEAN = 260;
public static final int BREAK = 261;
public static final int BYTE = 262;
public static final int CASE = 263;
public static final int CATCH = 264;
public static final int CHAR = 265;
public static final int CLASS = 266;
public static final int CONTINUE = 267;
public static final int DEFAULT = 268;
public static final int DO = 269;
public static final int DOUBLE = 270;
public static final int EXTENDS = 271;
public static final int FALSE_TOKEN = 272;
public static final int FINAL = 273;
public static final int FINALLY = 274;
public static final int FLOAT = 275;
public static final int FOR = 276;
public static final int IF = 277;
public static final int IMPLEMENTS = 278;
public static final int NSLIMPORT = 279;
public static final int INSTANCEOF = 280;
public static final int INT = 281;
public static final int INTERFACE = 282;
public static final int LONG = 283;
public static final int NATIVE = 284;
public static final int NULL_TOKEN = 285;
public static final int PACKAGE = 286;
public static final int PRIVATE = 287;
public static final int PROTECTED = 288;
public static final int PUBLIC = 289;
public static final int RETURN = 290;
public static final int SHORT = 291;
public static final int STATIC = 292;
public static final int SUPER = 293;
public static final int SWITCH = 294;
public static final int SYNCHRONIZED = 295;
public static final int THIS = 296;
public static final int THROW = 297;
public static final int THROWS = 298;
public static final int TRANSIENT = 299;
public static final int VOLATILE = 300;
public static final int TRUE_TOKEN = 301;
public static final int TRY = 302;
public static final int VOID = 303;
public static final int WHILE = 304;
public static final int VERBATIM_OFF = 305;
public static final int VERBATIM_NSLJ = 306;
public static final int VERBATIM_NSLC = 307;
public static final int NSLJ = 308;
public static final int NSLMULTI = 309;
public static final int CONNECT = 310;
public static final int SPECIAL = 311;
public static final int NSLMODULE = 312;
public static final int NSLMODEL = 313;
public static final int NSLCLASS = 314;
public static final int ARRAY = 315;
public static final int INT_LITERAL = 316;
public static final int CHARACTER_LITERAL = 317;
public static final int LONG_LITERAL = 318;
public static final int FLOAT_LITERAL = 319;
public static final int DOUBLE_LITERAL = 320;
public static final int SYMBOL = 321;
public static final int STRING_LITERAL = 322;
public static final int BIT_MUL = 323;
public static final int STRING = 324;
public static final int NOT_AN_OPERATOR = 325;
public static final int SHIFT_RIGHT_EQUALS = 326;
public static final int FILL_SHIFT_RIGHT_EQUALS = 327;
public static final int SHIFT_LEFT_EQUALS = 328;
public static final int ADD_EQUALS = 329;
public static final int SUB_EQUALS = 330;
public static final int MUL_EQUALS = 331;
public static final int DIV_EQUALS = 332;
public static final int MOD_EQUALS = 333;
public static final int AND_EQUALS = 334;
public static final int XOR_EQUALS = 335;
public static final int OR_EQUALS = 336;
public static final int OR = 337;
public static final int AND = 338;
public static final int EQUAL_COMPARE = 339;
public static final int NOT_EQUAL = 340;
public static final int LTEQ = 341;
public static final int GTEQ = 342;
public static final int BITSHIFT_RIGHT = 343;
public static final int FILL_SHIFT_RIGHT = 344;
public static final int SHIFT_LEFT = 345;
public static final int CAST = 346;
public static final int INCR = 347;
public static final int DECR = 348;
public static final int UMINUS = 349;
public static final int UPLUS = 350;
public static final int POST_INCR = 351;
public static final int POST_DECR = 352;
public static final int NEW = 353;
public static final int LOWER_THAN_ELSE = 354;
public static final int ELSE = 355;


public static final String tokennames[] = {
"ERROR", "ABSTRACT", "BOOLEAN", "BREAK", "BYTE", "CASE", "CATCH", "CHAR", "CLASS", "CONTINUE", "DEFAULT", "DO", "DOUBLE", "EXTENDS", "FALSE_TOKEN", "FINAL", "FINALLY", "FLOAT", "FOR", "IF", "IMPLEMENTS", "NSLIMPORT", "INSTANCEOF", "INT", "INTERFACE", "LONG", "NATIVE", "NULL_TOKEN", "PACKAGE", "PRIVATE", "PROTECTED", "PUBLIC", "RETURN", "SHORT", "STATIC", "SUPER", "SWITCH", "SYNCHRONIZED", "THIS", "THROW", "THROWS", "TRANSIENT", "VOLATILE", "TRUE_TOKEN", "TRY", "VOID", "WHILE", "VERBATIM_OFF", "VERBATIM_NSLJ", "VERBATIM_NSLC", "NSLJ", "NSLMULTI", "CONNECT", "SPECIAL", "NSLMODULE", "NSLMODEL", "NSLCLASS", "ARRAY", "INT_LITERAL", "CHARACTER_LITERAL", "LONG_LITERAL", "FLOAT_LITERAL", "DOUBLE_LITERAL", "SYMBOL", "STRING_LITERAL", "BIT_MUL", "STRING", "NOT_AN_OPERATOR", "SHIFT_RIGHT_EQUALS", "FILL_SHIFT_RIGHT_EQUALS", "SHIFT_LEFT_EQUALS", "ADD_EQUALS", "SUB_EQUALS", "MUL_EQUALS", "DIV_EQUALS", "MOD_EQUALS", "AND_EQUALS", "XOR_EQUALS", "OR_EQUALS", "OR", "AND", "EQUAL_COMPARE", "NOT_EQUAL", "LTEQ", "GTEQ", "BITSHIFT_RIGHT", "FILL_SHIFT_RIGHT", "SHIFT_LEFT", "CAST", "INCR", "DECR", "UMINUS", "UPLUS", "POST_INCR", "POST_DECR", "NEW", "LOWER_THAN_ELSE", "ELSE", null
};

public static String tokenname(int t)
{
    if(t >= tokenmin && t <= tokenmax) {
	return tokennames[t - tokenmin];
    } else if(t > 0 && t <= 255) {
	return "'" + String.valueOf((char)t) + "'";
    } else if(t == YYEOF) {
	return "EOF";
    } else {
	return "$undefined$";
    }
}

//////////////////////////////////////////////////

public static final int nontermmin = 356;
public static final int nontermmax = 444;

public static final int nt_compilationUnit = 356;
public static final int nt_optPackage = 357;
public static final int nt_importList = 358;
public static final int nt_nslImport = 359;
public static final int nt_typeDeclarationList = 360;
public static final int nt_typeDeclaration = 361;
public static final int nt_classDeclaration = 362;
public static final int nt_nslclassDecl1 = 363;
public static final int nt_nslclassDecl2 = 364;
public static final int nt_nslextends = 365;
public static final int nt_nslreturn = 366;
public static final int nt_nslclassBlock = 367;
public static final int nt_classDecl1 = 368;
public static final int nt_classDecl2 = 369;
public static final int nt_interfaceDeclaration = 370;
public static final int nt_interfaceDecl1 = 371;
public static final int nt_interfaceDecl2 = 372;
public static final int nt_classModifierList = 373;
public static final int nt_extends = 374;
public static final int nt_interfaceExtends = 375;
public static final int nt_interfaces = 376;
public static final int nt_classBlock = 377;
public static final int nt_fieldList = 378;
public static final int nt_field = 379;
public static final int nt_CARRAYDECL = 380;
public static final int nt_Carray = 381;
public static final int nt_nslInstantiation = 382;
public static final int nt_nslCouple = 383;
public static final int nt_nslArgs = 384;
public static final int nt_nslPars = 385;
public static final int nt_staticInitializer = 386;
public static final int nt_methodDeclaration = 387;
public static final int nt_methodDecl1 = 388;
public static final int nt_methodDecl3 = 389;
public static final int nt_constructorDeclaration = 390;
public static final int nt_constructorDecl1 = 391;
public static final int nt_constructorDecl2 = 392;
public static final int nt_optThrows = 393;
public static final int nt_optConstructorStatements = 394;
public static final int nt_methodBlock = 395;
public static final int nt_optParameterList = 396;
public static final int nt_parameterList = 397;
public static final int nt_parameter = 398;
public static final int nt_variableDeclaration = 399;
public static final int nt_subvariableDeclaration = 400;
public static final int nt_partialVariable = 401;
public static final int nt_optInitializer = 402;
public static final int nt_initializer = 403;
public static final int nt_optVariableInitializerList = 404;
public static final int nt_variableInitializerList = 405;
public static final int nt_optComma = 406;
public static final int nt_compoundStatement = 407;
public static final int nt_compoundStatement1 = 408;
public static final int nt_compoundStatement2 = 409;
public static final int nt_statementList = 410;
public static final int nt_statement = 411;
public static final int nt_optExpression = 412;
public static final int nt_forInit = 413;
public static final int nt_verbatim_line = 414;
public static final int nt_forIncr = 415;
public static final int nt_expressionStatements = 416;
public static final int nt_optFinally = 417;
public static final int nt_finally = 418;
public static final int nt_catchList = 419;
public static final int nt_catchItem = 420;
public static final int nt_expression = 421;
public static final int nt_symbolArrayExpression = 422;
public static final int nt_nonSymbolExpression = 423;
public static final int nt_nonSymbolComplexPrimary = 424;
public static final int nt_expressionStatement = 425;
public static final int nt_methodCall = 426;
public static final int nt_cast = 427;
public static final int nt_newExpression = 428;
public static final int nt_allocationBounds = 429;
public static final int nt_optArrayBounds = 430;
public static final int nt_literal = 431;
public static final int nt_optArgumentList = 432;
public static final int nt_argumentList = 433;
public static final int nt_type = 434;
public static final int nt_qualifiedSymbolWithLBracket = 435;
public static final int nt_simpleType = 436;
public static final int nt_Erh_simpleType = 437;
public static final int nt_XmodifierList = 438;
public static final int nt_modifierList = 439;
public static final int nt_qualifiedSymbol = 440;
public static final int nt_portrefSymbol = 441;
public static final int nt_portrefList = 442;
public static final int nt_qualifiedSymbolList = 443;
public static final int nt_simpleSymbol = 444;


public static final String nontermnames[] = {
"compilationUnit", "optPackage", "importList", "nslImport", "typeDeclarationList", "typeDeclaration", "classDeclaration", "nslclassDecl1", "nslclassDecl2", "nslextends", "nslreturn", "nslclassBlock", "classDecl1", "classDecl2", "interfaceDeclaration", "interfaceDecl1", "interfaceDecl2", "classModifierList", "extends", "interfaceExtends", "interfaces", "classBlock", "fieldList", "field", "CARRAYDECL", "Carray", "nslInstantiation", "nslCouple", "nslArgs", "nslPars", "staticInitializer", "methodDeclaration", "methodDecl1", "methodDecl3", "constructorDeclaration", "constructorDecl1", "constructorDecl2", "optThrows", "optConstructorStatements", "methodBlock", "optParameterList", "parameterList", "parameter", "variableDeclaration", "subvariableDeclaration", "partialVariable", "optInitializer", "initializer", "optVariableInitializerList", "variableInitializerList", "optComma", "compoundStatement", "compoundStatement1", "compoundStatement2", "statementList", "statement", "optExpression", "forInit", "verbatim_line", "forIncr", "expressionStatements", "optFinally", "finally", "catchList", "catchItem", "expression", "symbolArrayExpression", "nonSymbolExpression", "nonSymbolComplexPrimary", "expressionStatement", "methodCall", "cast", "newExpression", "allocationBounds", "optArrayBounds", "literal", "optArgumentList", "argumentList", "type", "qualifiedSymbolWithLBracket", "simpleType", "Erh_simpleType", "XmodifierList", "modifierList", "qualifiedSymbol", "portrefSymbol", "portrefList", "qualifiedSymbolList", "simpleSymbol", null
};

public static String nontermname(int t)
{
    if(t >= nontermmin && t <= nontermmax) {
	return nontermnames[t - nontermmin];
    } else {
	return "$undefined$";
    }
}

};
