/*
 * TraitementImage.java
 *
 * Created on 23 octobre 2003, 19:40
 */

package cannes.NSLWorld;
import VideoGrabber.*;
import java.io.*; 
import javax.imageio.* ;

/**
 *
 * @author  lecornes
 */

public class TraitementImage {    
    /** Creates a new instance of TraitementImage */
    // public TraitementImage() {} ; // Uniquement pour les tests
    
    public TraitementImage(/*int numImage,*/
                            java.awt.image.BufferedImage img1, java.awt.image.BufferedImage img2, // java.io.File premierFichier, java.io.File deuxiemeFichier, 
                            int imageSelectionnee,
                            int nbMarqueurs, int demiCoteMarqueur, int pasMarqueur, int distanceEntreMarqueurs, int seuilValiditeMarqueur,
                            int demiCoteOF, int pasOF, int ecartMaxGaucheDroite, int ecartMaxHautBas, 
                            int seuilDifference, int seuilAngle,
                            int echelleVueDessus) {                                

/*                                
        // Sauvegarde                         
        File f = new File("C:\\IMG\\img1_" + numImage + ".jpg"); 
        FileOutputStream fout ;
        try {
            try {
                fout = new FileOutputStream(f); 
                fout.close(); 
                ImageIO.write(img1, "jpg", f);
                f = new File("C:\\IMG\\img2_" + numImage + ".jpg"); 
                fout = new FileOutputStream(f); 
                fout.close(); 
                ImageIO.write(img2, "jpg", f);
            }
            catch(java.io.FileNotFoundException e1) {}
            // System.err.println("Erreur d'ouverture d'un fichier image"); 
            // e.printStackTrace(); 
        }                 
        catch(java.io.IOException e2) { }
  */                                      
        nombreMarqueurs = nbMarqueurs ;
        demiCoteCalculMarqueur = demiCoteMarqueur ;
        pasCalculMarqueur = pasMarqueur ;
        facteurDistanceMarqueurs = distanceEntreMarqueurs ;
        seuilContrasteValiditeMarqueur = seuilValiditeMarqueur ;
        
        demiCoteCalculOF = demiCoteOF ;
        pasCalculOF = pasOF ;
        ecartMaxGaucheDroiteOF = ecartMaxGaucheDroite ;
        ecartMaxHautBasOF = ecartMaxHautBas ;
        seuilDifferenceMaximale = seuilDifference ;
        seuilAngleOF = (float)(seuilAngle * 2 * java.lang.Math.PI) / (float)360 ; // Conversion en radians
        
        echelleCalculVueDessus = echelleVueDessus ;
        
        marqueurs = new java.awt.Point[nombreMarqueurs] ;
                
        imageAAfficher = imageSelectionnee ;
        
        traiterImage(img1, img2);
    }  
/*
    public static void main(String args[]) {
        java.awt.image.BufferedImage img = new java.awt.image.BufferedImage(10,10, java.awt.image.BufferedImage.TYPE_INT_RGB) ;
        
        TraitementImage t = new TraitementImage() ;
        t.marqueurs = new java.awt.Point[3] ;

        t.marqueurs[0] = new java.awt.Point(0,5) ;
        t.marqueurs[1] = new java.awt.Point(1,5) ;
        t.marqueurs[2] = new java.awt.Point(2,5) ;
        
        t.distances = new int[3] ;
        
        t.distances[0] = 5 ;
        t.distances[1] = 10 ;
        t.distances[2] = 15 ;        
        
        t.calculDroiteRegression(img) ;
    }
*/
//    public void traiterImage(java.io.File premierFichier, java.io.File deuxiemeFichier) {       
    public void traiterImage(java.awt.image.BufferedImage img1, java.awt.image.BufferedImage img2) {           
        image1 = img1 ;
        image2 = img2 ;
        java.util.Date date1, date2 ;
        
        if(image1 == null || image2 == null)
            System.err.println("Format d'image non reconnu"); 
        else
        {
            if(image1.getWidth() != image2.getWidth()
              || image1.getHeight() != image2.getHeight())
            {
                 System.err.println("Les deux fichiers n'ont pas la mme taille");
                 imageOF.getGraphics().setColor(java.awt.Color.BLACK);
                 imageOF.getGraphics().drawString("Les deux image n'ont pas la mme taille", 0, 10);
            }
            else
            {
//                date1 = new java.util.Date() ;
                imageContraste1 = calculContraste(image1) ;
                imageContraste2 = calculContraste(image2) ;
                
//                date2 = new java.util.Date() ;                
//                System.out.println("Calcul des contrastes : " + (date2.getTime() - date1.getTime()) + "ms") ;
//                date1 = date2 ;
                
                imageMarqueurs = rechercheMarqueurs(imageContraste1) ;
                
//                date2 = new java.util.Date() ;                
//                System.out.println("Recherche des marqueurs : " + (date2.getTime() - date1.getTime()) + "ms") ;
//                date1 = date2 ;                
                
                imageOF = calculOF(imageContraste1, imageContraste2) ;

//                date2 = new java.util.Date() ;                
//                System.out.println("Calcul des flux optiques : " + (date2.getTime() - date1.getTime()) + "ms") ;
//                date1 = date2 ;
                
                imageVueDessus = calculVueDeDessus(imageContraste1) ;

//                date2 = new java.util.Date() ;                
//                System.out.println("Calcul de la vue de dessus : " + (date2.getTime() - date1.getTime()) + "ms") ;
//                date1 = date2 ;
                
                imageDroiteRegression = calculDroiteRegression(imageVueDessus) ;

//                date2 = new java.util.Date() ;                
//                System.out.println("Calcul de la droite de regression : " + (date2.getTime() - date1.getTime()) + "ms") ;
//                date1 = date2 ;                
            }
        }
    }

    public void setImageAAfficher(int numeroImage) {
        if(numeroImage < 1 || numeroImage > 8)
            java.lang.System.out.println("setImageAAfficher : numro incorrect") ;
        else
            imageAAfficher = numeroImage ;
    }
    
    public java.awt.image.BufferedImage getImage() {
        java.awt.image.BufferedImage image = null ;
        switch(imageAAfficher)
        {
            case IMAGE_1:
                image = image1 ;
                break ;
            case IMAGE_2:
                image = image2 ;
                break ;
            case IMAGE_CONTRASTE_1:
                image = imageContraste1 ;
                break ;
            case IMAGE_CONTRASTE_2:
                image = imageContraste2 ;
                break ;
            case IMAGE_MARQUEURS:
                image = imageMarqueurs ;
                break ;
            case IMAGE_FLUX_OPTIQUE:
                image = imageOF ;
                break ;
            case IMAGE_VUE_DESSUS:
                image = imageVueDessus ;
                break ;
            case IMAGE_DROITE_REGRESSION:
                image = imageDroiteRegression ;
                break ;
        }
        return image ;
    }
    
    public void afficher(java.awt.Graphics g, java.awt.Canvas c) {   
        java.awt.image.BufferedImage image = getImage() ;

        if(image != null)
            g.drawImage(image, 0, 0, c);
    }
    
    private java.awt.image.BufferedImage calculDroiteRegression(java.awt.image.BufferedImage src) {
        java.awt.image.BufferedImage resultat = 
            new java.awt.image.BufferedImage(src.getWidth(), src.getHeight(), src.getType()) ;
        int n = 0 ;
        double valeur ;
        
        java.awt.Graphics g = resultat.getGraphics() ;
        
        g.drawImage(src, 0, 0, src.getWidth(), src.getHeight(), null) ;        
        
        double sumx = 0, sumy = 0, sumxx = 0, sumyy = 0, sumxy = 0 ;
        
        double Sxx, Sxy ;
        
        for(int i = 0 ; i < marqueurs.length ; i++)
            if(distances[i] != -1)
            {
                sumx += marqueurs[i].x ;
                sumxx += marqueurs[i].x * marqueurs[i].x ;
                sumy += distances[i] ;
                sumyy += distances[i] * distances[i] ;
                sumxy += distances[i] * marqueurs[i].x ;
                
                n++ ;
            }
        
        Sxx = sumxx - sumx * sumx / n ;
        Sxy = sumxy - sumx * sumy / n ;
        droiteDeRegressionA = Sxy / Sxx ;
        droiteDeRegressionB = (sumy - droiteDeRegressionA * sumx) / n ;
        
        g.drawLine(0, (int)(droiteDeRegressionB + src.getHeight() / 2), src.getWidth(), (int)(src.getWidth() * droiteDeRegressionA + droiteDeRegressionB + src.getHeight() / 2)) ;

        /*
        // Calcul la moyenne de la somme des ecarts avec la droite
        distanceMoyenneDroiteRegression = 0 ;
        for(int i = 0 ; i < marqueurs.length ; i++)
            if(distances[i] != -1)
            {
                valeur = droiteDeRegressionA * marqueurs[i].x + droiteDeRegressionB ;
                distanceMoyenneDroiteRegression += 
                    java.lang.Math.abs((valeur - distances[i]) / (valeur))  ;
            }
        distanceMoyenneDroiteRegression /= n ;
        
        System.out.println("Distance droite de regression : " + distanceMoyenneDroiteRegression) ;        
         */
        // System.out.println("Droite de regression : " + droiteDeRegressionA + " X + " + droiteDeRegressionB) ;
        
        return resultat ;
    }
    
    private java.awt.image.BufferedImage calculVueDeDessus(java.awt.image.BufferedImage src) {
        java.awt.image.BufferedImage resultat = 
            new java.awt.image.BufferedImage(src.getWidth(), src.getHeight(), src.getType()) ;
        java.awt.Graphics g = resultat.getGraphics() ;
        int position ;

        distances = new int[marqueurs.length] ;
        
        g.drawImage(src, 0, 0, src.getWidth(), src.getHeight(), null) ;
        g.drawLine(0, src.getHeight() / 2, src.getWidth(), src.getHeight() / 2) ;
        
        for(int i = 0 ; i < marqueurs.length ; i++)
        {
            if(fluxOptique[i].x != 0)
            {
                position = (echelleCalculVueDessus * src.getHeight()) / 2 / fluxOptique[i].x ;

                distances[i] = -position ;
                
                if(position > src.getHeight() / 2 - 2)
                    position = src.getHeight() / 2 - 2 ;
                if(position < - src.getHeight() / 2 - 2)
                    position = - src.getHeight() / 2 - 2 ;
                
                g.setColor(new java.awt.Color(marqueurs[i].y * 256 / src.getHeight(), marqueurs[i].y * 256 / src.getHeight(), 255)) ;// java.awt.Color.BLUE) ;
                g.fillRect(marqueurs[i].x - 2, src.getHeight() / 2 + position - 2, 5, 5) ;
            }
            else
                distances[i] = -1 ;
        }
        
        return resultat ;
    }    
    
    private java.awt.image.BufferedImage rechercheMarqueurs(java.awt.image.BufferedImage src) {
        java.awt.image.BufferedImage resultat = null ;
        int x, y, i, j ;
        int index ;
        // int valeur, valeurFonce, valeurClair, luminosite ;
        double variance, valeur, luminosite, luminositeMoyenne ;
        int[] element ;
        int[] element2 ;
        
        int ecartMaxDroiteOF ;
        
        java.util.List listePoints = new java.util.LinkedList() ; // liste de int[3], avec x, y, valeur, triee par valeurs dcroissantes
        
        if(CALCUL_QUE_GAUCHE_DROITE)
            ecartMaxDroiteOF = 0 ;
        else
            ecartMaxDroiteOF = ecartMaxGaucheDroiteOF ;
        
        // Parcours des pixels
        for(x = java.lang.Math.max(demiCoteCalculMarqueur, ecartMaxGaucheDroiteOF + demiCoteCalculOF) ; x < src.getWidth() - java.lang.Math.max(demiCoteCalculMarqueur, ecartMaxDroiteOF + demiCoteCalculOF) ; x += pasCalculMarqueur)
            for(y = java.lang.Math.max(demiCoteCalculMarqueur, ecartMaxHautBasOF + demiCoteCalculOF) ; y < src.getHeight() - java.lang.Math.max(demiCoteCalculMarqueur, ecartMaxHautBasOF + demiCoteCalculOF) ; y += pasCalculMarqueur)
            {
                
                // Calcul du score (ecart type) du pixel en cours (dans valeur)
                // Calcul de la moyenne de luminosite
                luminositeMoyenne = 0 ;
                for(i = x - demiCoteCalculMarqueur ; i < x + demiCoteCalculMarqueur ; i++)
                    for(j = y - demiCoteCalculMarqueur ; j < y + demiCoteCalculMarqueur ; j++)
                        luminositeMoyenne += calculLuminosite(src.getRGB(i, j)) ;
                luminositeMoyenne /= (2 * demiCoteCalculMarqueur) * (2 * demiCoteCalculMarqueur) ;
                // Calcul de la variance
                variance = 0 ;
                for(i = x - demiCoteCalculMarqueur ; i < x + demiCoteCalculMarqueur ; i++)
                    for(j = y - demiCoteCalculMarqueur ; j < y + demiCoteCalculMarqueur ; j++)
                    {
                        luminosite = calculLuminosite(src.getRGB(i, j)) ;
                        variance += (luminositeMoyenne - luminosite) * (luminositeMoyenne - luminosite) ;
                    }
                // Ecart type
                valeur = 100 * java.lang.Math.sqrt(variance / ((2 * demiCoteCalculMarqueur) * (2 * demiCoteCalculMarqueur))) ;
                /*
                valeurFonce = valeurClair = 1 ;
                
                // Calcul du score du pixel en cours (dans valeur)
                for(i = x - demiCoteCalculMarqueur ; i < x + demiCoteCalculMarqueur ; i++)
                    for(j = y - demiCoteCalculMarqueur ; j < y + demiCoteCalculMarqueur ; j++)
                    {
                        luminosite = calculLuminosite(src.getRGB(i, j)) ;
                        
                        if(luminosite >= 128)
                            valeurClair += (luminosite - 128) ;
                        else
                            valeurFonce += (128 - luminosite) ;
                    }
                 */
                /*
                if(valeurFonce < valeurClair)
                    valeur = valeurFonce ;
                else
                    valeur = valeurClair ;
                */
                // valeur = valeurFonce * valeurClair ;
                
                if(valeur > seuilContrasteValiditeMarqueur)
                {
                    element = new int[3] ;
                    element[0] = x ;
                    element[1] = y ;
                    element[2] = (int)valeur ;

                    // Recherche dans la liste ou l'insrer
                    for(index = 0 ; index < listePoints.size() && ((int[])listePoints.get(index))[2] > valeur ; index ++) 
                    {
                        // On insere que si il n'y a pas un autre point  ct avec un meilleur score
                        element2 = ((int[])listePoints.get(index)) ;
                        if(element2[0] > element[0] - facteurDistanceMarqueurs * demiCoteCalculMarqueur
                            && element2[0] < element[0] + facteurDistanceMarqueurs * demiCoteCalculMarqueur
                            && element2[1] > element[1] - facteurDistanceMarqueurs * demiCoteCalculMarqueur
                            && element2[1] < element[1] + facteurDistanceMarqueurs * demiCoteCalculMarqueur)
                            index = nombreMarqueurs ;
                    }

                    if(index < nombreMarqueurs)
                    {                    
                        listePoints.add(index, element) ;

                        // Recherche les points de poids plus faible qui touchent le dernier trouv
                        for(int index2 = index + 1 ; index2 < listePoints.size() ; index2++)
                        {
                            element2 = ((int[])listePoints.get(index2)) ;
                            if(element2[0] > element[0] - facteurDistanceMarqueurs * demiCoteCalculMarqueur
                                && element2[0] < element[0] + facteurDistanceMarqueurs * demiCoteCalculMarqueur
                                && element2[1] > element[1] - facteurDistanceMarqueurs * demiCoteCalculMarqueur
                                && element2[1] < element[1] + facteurDistanceMarqueurs * demiCoteCalculMarqueur)
                            {
                                // System.out.println("Suppression de " + element2[0] + " " + element2[1]) ;
                                listePoints.remove(index2) ;
                                index2-- ;
                            }   
                        }

                        if(listePoints.size() > nombreMarqueurs)
                            listePoints.remove(nombreMarqueurs - 1) ;
                    }
                }
            }   
        
        // Affichage sur l'image rsultat
        resultat = new java.awt.image.BufferedImage(src.getWidth(), src.getHeight(), src.getType());
        resultat.getGraphics().drawImage(src, 0, 0, src.getWidth(), src.getHeight(), null) ;
        
        for(i = 0 ; i < listePoints.size() ; i++)
        {
            element = ((int[])listePoints.get(i)) ;
            for(x = element[0] - demiCoteCalculMarqueur ; x < element[0] + demiCoteCalculMarqueur ; x++)
                if(x >= 0 && x < src.getWidth())
                    resultat.setRGB(x, element[1], 255);
                
            for(y = element[1] - demiCoteCalculMarqueur ; y < element[1] + demiCoteCalculMarqueur ; y++)
                if(y >= 0 && y < src.getHeight())
                    resultat.setRGB(element[0], y, 255); 
        }
        
        // Copie des informations dans "marqueurs"
        marqueurs = new java.awt.Point[listePoints.size()] ;
        for(i = 0 ; i < listePoints.size() ; i++)
            marqueurs[i] = new java.awt.Point(((int[])listePoints.get(i))[0], ((int[])listePoints.get(i))[1]) ;
        
        return resultat ;
    }
    
    private java.awt.image.BufferedImage calculOF(java.awt.image.BufferedImage src1, java.awt.image.BufferedImage src2) {    
        java.awt.image.BufferedImage resultat = 
            new java.awt.image.BufferedImage(src1.getWidth(), src1.getHeight(), src1.getType());
        resultat.getGraphics().drawImage(src1, 0, 0, src1.getWidth(), src1.getHeight(), null) ;
        
        int x, y ;
        int i, j ;
        int score ;
        int[] meilleurVecteur = new int[3] ; // 0 : x ; 1 : y ; 2 : valeur
        int ecartMaxDroiteOF ;
        
        java.awt.Graphics g ;
        
        fluxOptique = new java.awt.Point[marqueurs.length] ;
        
        if(CALCUL_QUE_GAUCHE_DROITE)
            ecartMaxDroiteOF = 1 ;
        else
            ecartMaxDroiteOF = ecartMaxGaucheDroiteOF ;
        
        // Parcours des marqueurs
        for(int index = 0 ; index < marqueurs.length ; index++)
        {
            // Parcours de tous les vecteurs possibles
            meilleurVecteur[0] = 0 ;
            meilleurVecteur[1] = 0 ;
            meilleurVecteur[2] = seuilDifferenceMaximale * demiCoteCalculOF * demiCoteCalculOF * 4 / pasCalculOF / pasCalculOF ;
            for(x = - ecartMaxGaucheDroiteOF ; x < ecartMaxDroiteOF ; x++)
                for(y = - ecartMaxHautBasOF ; y < ecartMaxHautBasOF ; y++)
                {
                    score = 0 ;
                    // Calcul de la somme des diffrences des points entre les 2 images
                    for(i = -demiCoteCalculOF ; i < demiCoteCalculOF ; i+=pasCalculOF)
                    {
                        for(j = -demiCoteCalculOF ; j < demiCoteCalculOF ; j+=pasCalculOF)
                            score += java.lang.Math.abs(
                                calculLuminosite(src1.getRGB(marqueurs[index].x + i, marqueurs[index].y + j))
                                - calculLuminosite(src2.getRGB(x + marqueurs[index].x + i, y + marqueurs[index].y + j))) ;

                        /* TODO : continuer 
                        // A chaque ligne, on vrifie si l'erreur est trop grande ou non
                        if(i > 2 && score / (i + demiCoteCalculOF + 1) / (demiCoteCalculOF * 2) / pasCalculOF / pasCalculOF > seuilDifferenceMaximale)
                        {
                            score = seuilDifferenceMaximale * demiCoteCalculOF * demiCoteCalculOF * 4 + 1 ;
                            i = demiCoteCalculOF ;
                        }
                         */
                    }
                    
                    if(meilleurVecteur[2] > score)
                    {
                        meilleurVecteur[0] = x ;
                        meilleurVecteur[1] = y ;
                        meilleurVecteur[2] = score ;
                    }
                }                
            fluxOptique[index] = new java.awt.Point(meilleurVecteur[0], meilleurVecteur[1]) ;
        }
        
        // Suppression des OF dont l'angle differe trop des autres
        {
            float angle1 = 0, angle2 = 0 ;
            int cpt = 0 ;
            double poids ;
            
            // Calcul de l'angle moyen
            for(int index = 0 ; index < marqueurs.length ; index++) 
            {       
                if(fluxOptique[index].x != 0 || fluxOptique[index].y != 0)
                {
                    poids = java.lang.Math.sqrt(java.lang.Math.pow(fluxOptique[index].y, 2) + java.lang.Math.pow(fluxOptique[index].x, 2)) ;
                    
                    angle1 += poids * java.lang.Math.atan2(fluxOptique[index].y, java.lang.Math.abs(fluxOptique[index].x)) ;
                    angle2 += poids * java.lang.Math.atan2(java.lang.Math.abs(fluxOptique[index].y), fluxOptique[index].x) ;
                    
                    cpt += poids ;
                }
            }
            angle1 /= cpt ;
            angle2 /= cpt ;
            
//            System.out.println("Angle 1 : " + angle1 + " Angle 2 : " + angle2) ;
//            System.out.println("Seuil : " + seuilAngleOF) ;
            
            // Recherche des OF qui ne correspondent pas
            for(int index = 0 ; index < marqueurs.length ; index++) 
            {
                if(java.lang.Math.abs(
                    java.lang.Math.atan2(fluxOptique[index].y, java.lang.Math.abs(fluxOptique[index].x))
                    - angle1) > seuilAngleOF ||
                    java.lang.Math.atan2(java.lang.Math.abs(fluxOptique[index].y), fluxOptique[index].x)
                    - angle2 > seuilAngleOF)
                {
//                    System.out.println("Efface : " + java.lang.Math.atan2(fluxOptique[index].y, java.lang.Math.abs(fluxOptique[index].x))
//                        + " ; " + java.lang.Math.atan2(java.lang.Math.abs(fluxOptique[index].y), fluxOptique[index].x)) ;            
                    fluxOptique[index].x = fluxOptique[index].y = 0 ;
                }
            }
        }
        
        // Affichage des rsultats
        for(int index = 0 ; index < marqueurs.length ; index++)
        {
            if(fluxOptique[index].x != 0 || fluxOptique[index].y != 0)
            {
                for(i = -3 ; i < 3 ; i++)
                    for(j = -3 ; j < 3 ; j++)
                        resultat.setRGB(marqueurs[index].x + i, marqueurs[index].y + j, 255*256*256) ;
                /*
                for(i = -3 ; i < 3 ; i++)
                    for(j = - 3 ; j < 3 ; j++)
                        resultat.setRGB(marqueurs[index].x + fluxOptique[index].x / 2 + i, marqueurs[index].y + fluxOptique[index].y / 2 + j, 255) ;            
                 */
                g = resultat.getGraphics() ;
                
                g.setColor(java.awt.Color.WHITE) ;
                g.drawLine(marqueurs[index].x, marqueurs[index].y, marqueurs[index].x + fluxOptique[index].x, marqueurs[index].y + fluxOptique[index].y) ;
            }
        }

        return resultat ;
    }
    
    private java.awt.image.BufferedImage calculDifference(java.awt.image.BufferedImage src1, java.awt.image.BufferedImage src2) {    
        java.awt.image.BufferedImage resultat = new java.awt.image.BufferedImage(src1.getWidth(), 
                                                        src1.getHeight(), 
                                                        src1.getType());
        int x, y ;
        java.awt.Color col1, col2 ;        
                
        for(x=0 ; x<resultat.getWidth() ; x++)
            for(y=0 ; y<resultat.getHeight() ; y++)
            {
                col1 = new java.awt.Color(src1.getRGB(x, y));
                col2 = new java.awt.Color(src2.getRGB(x, y));

                resultat.setRGB(x, y,
                    (new java.awt.Color(java.lang.Math.abs(col1.getRed() - col2.getRed()), 
                                        java.lang.Math.abs(col1.getGreen() - col2.getGreen()), 
                                        java.lang.Math.abs(col1.getBlue() - col2.getBlue())).getRGB()));
            }        
        return resultat;
    }
    
    private java.awt.image.BufferedImage calculContraste(java.awt.image.BufferedImage src) {
        java.awt.image.BufferedImage resultat = new java.awt.image.BufferedImage(src.getWidth(), 
                                                        src.getHeight(), 
                                                        src.getType());
        int x, y, i, j, colContraste;
        java.awt.Color col1, col2 ;        
                
        for(x=1 ; x<resultat.getWidth() - 1 ; x++)
            for(y=1 ; y<resultat.getHeight() - 1 ; y++)
            {
                col1 = new java.awt.Color(src.getRGB(x, y));

                colContraste = 0;
                for(i = -1 ; i < 1 ; i++)
                    for(j = -1 ; j < 1 ; j++)
                    {
                        col2 = new java.awt.Color(src.getRGB(x+i, y+j));
                                
                        colContraste += java.lang.Math.abs(col1.getRed() - col2.getRed());
                        colContraste += java.lang.Math.abs(col1.getBlue() - col2.getBlue());
                        colContraste += java.lang.Math.abs(col1.getGreen() - col2.getGreen());                                
                    }
                colContraste /= 3 ;
                if(colContraste > 255)
                    colContraste = 255;
                resultat.setRGB(x, y,
                    (new java.awt.Color(colContraste, colContraste, colContraste).getRGB()));
            }        
        return resultat;
    }
    
    private java.awt.image.BufferedImage calculContrasteRGB(java.awt.image.BufferedImage src) {
        java.awt.image.BufferedImage resultat = new java.awt.image.BufferedImage(src.getWidth(), 
                                                        src.getHeight(), 
                                                        src.getType());
        int x, y, i, j ;
        int[] colContraste;
        java.awt.Color col1, col2 ;        
             
        colContraste = new int[3] ;
        
        for(x=1 ; x<resultat.getWidth() - 1 ; x++)
            for(y=1 ; y<resultat.getHeight() - 1 ; y++)
            {
                col1 = new java.awt.Color(src.getRGB(x, y));

                colContraste[0] = colContraste[1] = colContraste[2] = 0;
                for(i = -1 ; i < 1 ; i++)
                    for(j = -1 ; j < 1 ; j++)
                    {
                        col2 = new java.awt.Color(src.getRGB(x+i, y+j));
                                
                        colContraste[0] += java.lang.Math.abs(col1.getRed() - col2.getRed());
                        colContraste[1] += java.lang.Math.abs(col1.getGreen() - col2.getGreen());                                
                        colContraste[2] += java.lang.Math.abs(col1.getBlue() - col2.getBlue());
                    }

                if(colContraste[0] > 255)
                    colContraste[0] = 255;
                if(colContraste[1] > 255)
                    colContraste[1] = 255;
                if(colContraste[2] > 255)
                    colContraste[2] = 255;
                resultat.setRGB(x, y,
                    (new java.awt.Color(colContraste[0], colContraste[1], colContraste[2]).getRGB()));
            }        
        return resultat;
    }
        
    // Retourne la luminosit de la couleur, de 0  255
    private int calculLuminosite(int couleur) {
        java.awt.Color col = new java.awt.Color(couleur) ;
        
        return (col.getRed() + col.getGreen() + col.getBlue()) / 3 ;
    }
    
    public int[][] abcissesOrdonneesDistances() {
        int[][] resultat = new int[distances.length][3] ;
        int i ;
        
        for(i=0 ; i<distances.length ; i++)
        {
            resultat[i][0] = distances[i] ;
            resultat[i][1] = marqueurs[i].x;
            resultat[i][2] = marqueurs[i].y ;
        }
        
        return resultat ;
    }
    
    public int largeurImages() {
        return image1.getWidth();
    }
    
    private java.awt.image.BufferedImage image1 = null, image2 = null; // Images d'origine
    private java.awt.image.BufferedImage imageContraste1 = null, imageContraste2 = null; // Calcul des contrastes
    private java.awt.image.BufferedImage imageMarqueurs = null ;
    private java.awt.image.BufferedImage imageOF = null ;
    private java.awt.image.BufferedImage imageVueDessus = null ;
    private java.awt.image.BufferedImage imageDroiteRegression = null ;
    java.awt.Point[] marqueurs ;
    // Pour chaque marqueur, contient un point reprsentant le vecteur OF
    java.awt.Point[] fluxOptique ;
    int[] distances ;
    
    private double droiteDeRegressionA ;
    private double droiteDeRegressionB ;
    // private double distanceMoyenneDroiteRegression ; 
    
    private int nombreMarqueurs ;
    private int demiCoteCalculMarqueur ;
    private int pasCalculMarqueur ;
    private int facteurDistanceMarqueurs ;
    private int seuilContrasteValiditeMarqueur ;
    
    private int demiCoteCalculOF ;
    private int pasCalculOF ;
    private int ecartMaxGaucheDroiteOF ;
    private int ecartMaxHautBasOF ;
    private int seuilDifferenceMaximale ;
    private float seuilAngleOF ;
    
    private int echelleCalculVueDessus ;
    
    // Image que l'on veut afficher
    private int imageAAfficher ;
    
    // Dtermine si le calcul considre un dplacement gauche-droite, ou les 2
    public final boolean CALCUL_QUE_GAUCHE_DROITE = true ;
    
    // Constantes pour choisir l'image  afficher
    public static final int IMAGE_1 = 1 ;
    public static final int IMAGE_2 = 2 ;
    public static final int IMAGE_CONTRASTE_1 = 3 ;
    public static final int IMAGE_CONTRASTE_2 = 4 ;
    public static final int IMAGE_MARQUEURS = 5 ;
    public static final int IMAGE_FLUX_OPTIQUE = 6 ;
    public static final int IMAGE_VUE_DESSUS = 7 ;
    public static final int IMAGE_DROITE_REGRESSION = 8 ;
}
