package cannes.NSLWorld;

import javax.media.j3d.Canvas3D;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.image.codec.jpeg.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
import com.sun.j3d.utils.universe.*;

import javax.media.j3d.Canvas3D;

// The Universe
import com.sun.j3d.utils.universe.SimpleUniverse;

// The BranchGroup
import javax.media.j3d.BranchGroup;

// For the Box
// The directional light
import javax.media.j3d.DirectionalLight;

// For the bouding sphere of the light source
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Appearance;
import javax.media.j3d.Material;

// Transformgroup
import javax.media.j3d.TransformGroup;


/**
 *
 * @author  rodolfo
 */
public class WorldCanvas extends Canvas3D{
    
    protected SimpleUniverse simpleU;
    protected worldBranchGroup rootBranchGroup;
    protected boolean set = false;
    protected java.awt.image.Raster realraster;
    private BufferedImage image ;
    
    /** Creates a new instance of Canvas3dRasterReader */
    public WorldCanvas(GraphicsConfiguration gc, worldBranchGroup branchGroup) {
	super(gc);
        rootBranchGroup = branchGroup;
        initialSetup();
        finalise();
    }
    
    
    public WorldCanvas(GraphicsConfiguration gc) {
	super(gc);
    }
    
    public void setBranchGroup(worldBranchGroup branchGroup) {
        rootBranchGroup = branchGroup;
        initialSetup();
        finalise();
    }
    
    
    public void postSwap() {
	GraphicsContext3D  ctx = getGraphicsContext3D();
	Raster ras ;
        // The raster components need all be set!
	 ras = new Raster( new Point3f(0f,0f,0f), Raster.RASTER_COLOR,
                          0,0,
                          WorldFrame.TAILLE_IMAGES,WorldFrame.TAILLE_IMAGES,
                          new ImageComponent2D(
                                ImageComponent.FORMAT_RGB,
                                new BufferedImage(WorldFrame.TAILLE_IMAGES,WorldFrame.TAILLE_IMAGES,
                                BufferedImage.TYPE_INT_RGB)), 
                          null);        
         
        ctx.readRaster(ras);
        realraster = ras.getImage().getImage().getRaster();
        image = ras.getImage().getImage();
//        image = (BufferedImage)(ras.getImage().getRenderedImage()) ;// 
    }
    
    public BufferedImage getImage() {
        return image;
    }
    
    protected void initialSetup() {
        if(!set) {
            simpleU = new SimpleUniverse((Canvas3D)this);
            set = true;
        }
    }
    
    public void finalise() {
        // Then add the branch group into the Universe        
	simpleU.addBranchGraph(rootBranchGroup);

        // And set up the camera position
        Viewer v[] = simpleU.getViewingPlatform().getViewers();
        v[0].getView().setFrontClipDistance(0.008);
        // Set camera angle
        v[0].getView().setFieldOfView(Math.toRadians(WorldFrame.ANGLE_CAMERA));// 1.57); 
	simpleU.getViewingPlatform().setNominalViewingTransform();
    }
    
    public void moveCamera(Vector3f vector){
        TransformGroup viewTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        Vector3f vec = new Vector3f();
        
        Transform3D temp = new Transform3D();
        viewTrans.getTransform(temp);
        temp.get(vec);
        
        vector.x += vec.x;
        vector.y += vec.y;
        vector.z += vec.z;
        
        temp.setTranslation(vector);     
        
        viewTrans.setTransform(temp);
    }
    
    public void moveRobotCamera(double degrees) {
        rootBranchGroup.rotateRobotCamera(degrees);
    }
    
    public void moveRobotBody(double degrees) {
        rootBranchGroup.rotateRobotBody(degrees);
    }
    
    public void moveRobot(Vector3f vector) {
        rootBranchGroup.moveRobot(vector);
    }

    public void moveRobot(double degrees) {
        //rotate the robot's camera
        TransformGroup viewTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        Transform3D myTransform3D2 = new Transform3D();
        myTransform3D2.rotY(Math.toRadians(degrees));
        
        Transform3D temp = new Transform3D();
        viewTrans.getTransform(temp);
        
        temp.mul(myTransform3D2);
        viewTrans.setTransform(temp);
        
        rootBranchGroup.rotateRobotCamera(degrees);        
    }    
}
