/*
 * FrameInterno.java
 *
 * Created on March 13, 2002, 3:51 PM
 */

/**
 *
 * @author  rodolfo
 *
 *
 *
 */

package cannes.CanCam;

import com.sun.media.ui.*;
import javax.media.*;
import javax.media.util.*;
import javax.media.format.*;
import javax.media.control.*;
import javax.media.protocol.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import cannes.CanCam.WriteProtocol.*;


class FrameInterno extends JInternalFrame implements ControllerListener, ImageSource
{
    // Declaracin de objetos importantes para el guardado de la imgen
    private SnapFrame frameSnap = null;
    private FrameGrabbingControl controlGrabber;
    private Frame frame = null;
 
    // Componentes indispensables para produccin y presentacin del media data
    public Player mplayer;
    public Component visual = null;
    public Component control = null;

    // imagen
    private Image image=null;
    boolean firstTime = true;
    int ancho         = 0;
    int altura        = 0;
    int alturaControl = 30;
    int anchInterna   = 10;
    int altInterna    = 30;

/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/

    public FrameInterno(Player player, String title)
    {
	  //super(title, true, true, true, true);
	  super("WebCam 01", true, true, true, true);
          //System.out.println("Creacion del FrameInterno");
	  getContentPane().setLayout(new BorderLayout());
	  setSize(320,10);
	  setLocation(10,10);
          setVisible(true);
          
          mplayer = player;
	  mplayer.addControllerListener((ControllerListener) this);
          
          System.out.println("Entra al FrameInterno");
          System.out.println("Going to realize");

	  mplayer.realize();
          
          addInternalFrameListener( new InternalFrameAdapter() {
              public void internalFrameClosing(InternalFrameEvent ife) {
                  dispose();
                  mplayer.close();
              }
          } );
    }

    public void doSnapShot () {
     Buffer          bufferFrame;
     BufferToImage   bufferToImage;
     //Image           image;
     //JPGWriterThread wrtr=null;

     controlGrabber = (FrameGrabbingControl) mplayer.getControl("javax.media.control.FrameGrabbingControl");              
     bufferFrame = controlGrabber.grabFrame ();
     bufferToImage = new BufferToImage ( (VideoFormat)bufferFrame.getFormat() );
     image = bufferToImage.createImage ( bufferFrame );

     //wrtr=new JPGWriterThread(image,"c:/usuarios/rodolfo/imagen.jpg");
     //wrtr.run();

     if(frameSnap==null)
      frameSnap = new SnapFrame ( image );
     else
      frameSnap.setImage( image );
     frameSnap.setTitle ("Snapshot" );
    }

    public Image getSnapShot() {
        return image;
    }


    





    public void controllerUpdate(ControllerEvent event)


    {


        if (event instanceof RealizeCompleteEvent)


        {


          System.out.println("Realize complete");


	      mplayer.prefetch();


	    }


        else if (event instanceof PrefetchCompleteEvent)


        {


	      if (visual != null)


            return;


	      if ((visual = mplayer.getVisualComponent()) != null)


          {


		  Dimension size = visual.getPreferredSize();


		  ancho = size.width;


		  altura = size.height;


		  getContentPane().add("Center", visual);


	      }


          else


		  ancho = 320;


	      if ((control = mplayer.getControlPanelComponent()) != null)


            {


		alturaControl = control.getPreferredSize().height;


		getContentPane().add("South", control);


	    }





            setSize(ancho + anchInterna, altura + alturaControl + altInterna);


	    validate();


	    mplayer.start();


	    }


        else if (event instanceof EndOfMediaEvent)


        {


	      mplayer.setMediaTime(new Time(0));


	      mplayer.start();


	    }


        else


        {


            event.toString() ;


        }


    }


    


    //Funciones heredadas de ImageSource


    public Image getImage() {


        this.doSnapShot();


        return this.getSnapShot();


    }


    


    


    }


