/*
 * JPGWriterThread.java
 *
 * Created on March 14, 2002, 12:59 PM
 */

/**
 *
 * @author  rodolfo
 */

package cannes.CanCam;

import java.awt.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import java.io.*;
import java.util.*;
import cannes.CanCam.WriteProtocol.*;

public class JPGWriterThread implements Runnable, WriteInterface{

    protected Thread t;
    protected Image image;
    protected String file;
    protected boolean written=false;

    /** Creates a new instance of JPGWriterThread */
    public JPGWriterThread(Image imagen, String archivo) {
        //System.out.println("Creacion del JPEGWriter");
        this.set(imagen,archivo);
        this.t=new Thread(this);
    }

    public JPGWriterThread(String archivo) {
        this.set(archivo);
    }

    public void set(Image imagen, String archivo) {
        this.image=imagen;
        this.file=archivo;
    }

    public void set(Image imagen) {
        this.image=imagen;
    }

    public void set(String archivo) {
        this.file=archivo;
    }

    //FUNCIONES HEREDADAS DE WRITEINTERFACE    
    public void write() {
        this.written=false;
        BufferedImage buf = new BufferedImage(
                                            image.getWidth(null),
                                            image.getHeight(null),
                                            BufferedImage.TYPE_INT_BGR);

        Graphics g = buf.createGraphics();

        g.drawImage(image,0,0,null);
        try{
            File theFile = new File(file);

            JPEGCodec.createJPEGEncoder(new FileOutputStream(theFile)).encode(buf);
        }
        catch(java.io.IOException ioe) {
            System.out.println(ioe.getMessage());
        }

        this.written=true;
    }

    public boolean isWritten() {
        return this.written;
    }

    //FUNCIONES HEREDADES DE RUNNABLE
    public void run() {
        this.write();   
    }
}


