/*
 * ClientSideProtocol.java
 *
 * Created on April 18, 2002, 3:25 PM
 */

package cannes.CanCam.WriteProtocol;

/**
 *
 * @author  rodolfo
 */

import java.net.*;
import java.io.*;

public final class ClientSideProtocol {

    private DatagramSocket Socket;
    private InetAddress Server;
    private int Port;

    /** Creates a new instance of ClientSideProtocol */
    public ClientSideProtocol(String server, int port) throws IOException {
        this.Socket=new DatagramSocket();
        this.Server=InetAddress.getByName(server);
        this.Port=port;   
    }

    public void SayHello() throws IOException {
        this.SendMessage("h");
        this.ReceiveMessage(2);
    }

    public void SayWrite() throws IOException {
        this.SendMessage("w"); 
        this.ReceiveMessage(2);
    }

    public void SayBye() throws IOException {
        this.SendMessage("b");
        this.ReceiveMessage(2);
    }

    private DatagramPacket createDatagram(String m,InetAddress Server,int Port)
    throws IOException {
        byte[] buffer=new byte[m.length()];

        buffer=m.getBytes();
        return new DatagramPacket(buffer,buffer.length,Server,Port);
    }

    private void SendMessage(String message) throws IOException {
        this.Socket.send(this.createDatagram(message,this.Server,this.Port));
    }

    private String ReceiveMessage(int Size) throws IOException {
        DatagramPacket r;
        byte[] buffer=new byte[Size];

        r=new DatagramPacket(buffer,buffer.length);
        this.Socket.receive(r);
        return new String(r.getData(),0,r.getLength());
    }
}


        


   


