/*
 * ServerSideProtocol.java
 *
 * Created on April 16, 2002, 4:00 AM
 */

package cannes.CanCam.WriteProtocol;

/**
 *
 * @author  rodolfo
 */

import java.io.*;
import java.net.*;

public class ServerSideProtocol extends Thread {

    int             puerto;
    WriteInterface  Writer;
    ImageSource     Source;
    ServerSocket    Server;

    /** Creates a new instance of ServerSideProtocol */
    public ServerSideProtocol(WriteInterface writer,ImageSource source, int puerto) {
        System.out.println("ServerSideProtocol");
        this.Writer=writer;
        this.Source=source;
        this.puerto=puerto;
        this.start();
    }
    
    public String Procesa(char Comando) {
     switch(Comando)
     {
         case 'h': return this.retOK();
         case 'w': this.Writer.set(this.Source.getImage());
                   this.Writer.write();
                   return this.retOK();
         case 'b': return this.bye();
         default:  return "?";
     }
    }

    private void listen() throws IOException, SocketException {
     DatagramSocket Server;
     DatagramPacket rpack,spack;
     byte[]           rbuf=new byte[10];
     byte[]           sbuf=new byte[10];
     String         re=null;

     Server=new DatagramSocket(this.puerto);
     System.out.println("Servidor escuchando en el puerto " + this.puerto);

     while(true) {
      rpack=new DatagramPacket(rbuf,rbuf.length);
      Server.receive(rpack);
      re=new String(rpack.getData(),0,rpack.getLength());
      //System.out.println("Entrada: "+re);

      if(re.length()>0)
       re=this.Procesa(re.charAt(0));
       //System.out.println("Salida: "+re);
      
      sbuf=re.getBytes();
      spack=new DatagramPacket(sbuf,sbuf.length,
                    rpack.getAddress(),rpack.getPort());
      Server.send(spack);
     }
    }

    public static String retOK() {
        return "!";
    }

    public static String bye() {
        return "b";
    }

    public void run() {
        try {
            this.listen();
        }
        catch (IOException e) {
            System.out.println(e);
         } 


    }


    


}


