package cannes.Imaging.ColorModel;





/*


 * rgbElement.java


 *


 * Created on April 26, 2002, 1:03 AM


 */





/**


 *


 * @author  Rodolfo Cartas, rodolfocartas@ieee.org


 */





/**


 *  La clase hsvElement se utiliza para encapsular colores de acuerdo al


 *  valor RGB (Red, Green, Blue);


 */


public class rgbElement {


    


    /** Indica el atributo Red


     */    


    public static final int rgbRed = 0;


    /** Indica el atributo Verde


     */    


    public static final int rgbGreen = 1;


    /** Indica el atributo Azul


     */    


    public static final int rgbBlue = 2;


    


    private int Red;


    private int Green;


    private int Blue;


    


    /** Crea una nueva instancia de rgbElement a partir de los valores RGB


     * proporcionados.


     * @param r Valor de rojo(0-255)


     * @param g Valor de verde(0-255)


     * @param b Valor de azul(0-255)


     */


    public rgbElement(int r, int g, int b) {


        this.Red = r;


        this.Green = g;


        this.Blue = b;


    }


    


    /** Obtiene el valor de un elemento de color RGB.


     * @param element El atributo a ser devuelto.


     * @return El atributo de acuetdo a element


     */


    public int getElement(int element) {


        switch( element ) {


            case rgbRed:


                return this.Red;


            case rgbGreen:


                return this.Green;


            case rgbBlue:


                return this.Blue;


            default:


                return -1;


        }


    }


        


    /** Convierte el objeto en una cadena.


     * @return El objeto en cadena.


     */    


    public String toString() {


        return "RGB " + this.Red + "," + this.Green + "," + this.Blue;


    }      


    


    /** Compara este objeto con otro.


     * @param obj El objeto a ser comparado.


     * @return <I>True</I> si so los objetos son iguales.


     * <I>False</I> cc


     */    


    public boolean equals(Object obj) {


        rgbElement q = (rgbElement)obj;


        if( this.Red == q.Red && this.Green == q.Green && this.Blue == q.Blue )


            return true;


        else


            return false;


    }


}


