/*


 * ImagingDisplayer.java


 *


 * Created on May 2, 2002, 1:52 AM


 */





package cannes.Imaging.Control;





/**


 *


 * @author  Rodolfo Cartas, rodolfocartas@ieee.org


 */





import cannes.Imaging.ops.*;


import cannes.Imaging.gui.*;


import javax.media.jai.widget.*;


import cannes.Imaging.ops.util.ImageSourceVector;





/** La clase <I>ImagingDisplayer</I> se utiliza para desplegar en un objeto


 * <I>ImagingMain</I> las imagenes que genera un objeto <I>ImagingProcessor</I>


 */


public class ImagingDisplayer {


      


    private ImagingMain DSP;


    private ImagingProcessor Source;


    private ImageCanvas[] displays;


    


    


    /** Crea una nueva instancia de ImagingPlayer


     * @param dsp Un objeto <I>ImagingMain</I> donde se desplegaran las imagenes


     * obtenidas de source


     * @param source Proporciona las imagenes que se desplegaran en dsp


     */


    public ImagingDisplayer(ImagingMain dsp, ImagingProcessor source) {


        this.DSP = dsp;


        this.Source = source;


        this.createFrames();


        


    }


    


    private void createFrames() {


        ImageSourceVector Images = this.Source.getImages();


        this.displays = new ImageCanvas[ Images.size() ];


        


        for(int i=0; i < this.displays.length; i++) {


            this.displays[i] = new ImageCanvas(Images.getSource(i).getImage());


            DSP.addImage(this.displays[i]);


        }


        


        DSP.pack();


        DSP.show();


    }


    


    /** Despliega las imagenes que se obtienen del procesador de imagenes.


     */    


    public void display() {


        ImageSourceVector Images;


        


        this.Source.Reload();


        Images = this.Source.getImages();


        


        for(int i=0; i < this.displays.length; i++)


            this.displays[ i ].set( Images.getSource(i).getImage() );


    }


    


}


