/*



 * ImagingManager.java



 *



 * Created on May 2, 2002, 1:11 AM



 */







package cannes.Imaging.Control;







/**



 *



 * @author  Rodolfo Cartas, rodolfocartas@ieee.org



 */







import cannes.Imaging.gui.*;



import cannes.IPObjects.*;



import java.util.Timer;



import java.util.Vector;











/** La clase <I>ImagingManager</I> se usa para crear un ambiente para procesar una



 * imagen que se lee desde un archivo.



 */



public class ImagingManager {



    



    private ImagingMain gui;



    private ImagingProcessor processor;



    private ImagingDisplayer displayer ;



    private ObjectServer     GridServer;



    



    public ImagingManager(Vector param) {



        switch(param.size()) {



        



            case 1:



                this.init((String)param.get(0));



                this.startReading(new ImagingRefresher(this.displayer), 500);



                break;



                



            case 3:



                this.init((String)param.get(0));



                this.startReading(



                    new ImagingRefresherIP(



                                        this.displayer,



                                        (String)param.get(1),



                                        Integer.parseInt((String)param.get(2))),



                                        500);



                break;



                



            case 4:



                this.init((String)param.get(0));



                this.startReading(



                    new ImagingRefresherIP(



                                        this.displayer,



                                        (String)param.get(1),



                                        Integer.parseInt((String)param.get(2))),



                                        500);



                this.GridServer = new ObjectServer(



                                        this.processor,



                                        Integer.parseInt((String)param.get(3)));



                break;



        }



    }



        



    



    /** Inicializa los componentes */



    private void init(String file) {



        this.gui = new ImagingMain();



        this.gui.show();



        



        this.processor = new ImagingProcessor(file);



        this.processor.Reload();



        this.displayer = new ImagingDisplayer(this.gui,this.processor);



        this.displayer.display();



    }



    



    /** Comienza la lectura */



    private void startReading(ImagingRefresher dsp, int Periodo) {



        Timer timer;



        timer=new java.util.Timer();



        timer.schedule(dsp,0,Periodo);



    } 



         



}



