/*



 * ImageArithmetic.java



 *



 * Created on June 10, 2002, 12:00 AM



 */







package cannes.Imaging.ops;







/**



 *



 * @author  Rodolfo Cartas, rodolfocartas@ieee.org



 */







import javax.media.jai.*;



import java.awt.image.renderable.*;







/** La clase ImageArithmetic proporciona operadores aritmticos para procesar



 * imgenes.



 */



public class ImageArithmetic implements ImageSource {



    



    /** La operacin Suma



     */    



    public final static int Add = 0;



    /** La operacin Resta



     */    



    public final static int Subtract = 1;



    /** La operacin Multiplicacin



     */    



    public final static int Multiply = 2;



    /** La operacin Divisin



     */    



    public final static int Divide = 3;



    



    private int         op;



    private PlanarImage target;



    private ImageSource source1, source2;



    



    /** Crea una nueva instancia de ImageArithmetic



     * @param s1 Imagen a operar



     * @param s2 Imagen a operar



     * @param op Operacin



     */



    public ImageArithmetic(ImageSource s1, ImageSource s2, int op) {



        this.op = op;



        



        this.source1 = s1;



        this.source2 = s2;



        



        this.doOp();



    }



    



    private void doOp() {



        ParameterBlock pb = new ParameterBlock();



        pb.addSource(this.source1.getImage());



        pb.addSource(this.source2.getImage());







//        System.out.println("Combinando fuentes");



        



        switch( this.op ) {



            case Add:



                this.target = JAI.create("add", pb, null);



                break;



            case Subtract:



                this.target = JAI.create("subtract", pb, null);



                break;



            case Multiply:



                this.target = JAI.create("multiply", pb, null);



                break;



            case Divide:



                this.target = JAI.create("divide", pb, null);



                break;



        }



    }



        



    



    /** Obtiene la imagen del objeto



     * @return La imagen procesada.



     */



    public PlanarImage getImage() {



        return this.target;



    }



    



    /**



     */    



    public ImageSource getSource() {



        return this.source1;



    }



    



    public void reload() {



        this.doOp();



    }



    



    public void setImage(PlanarImage image) {



    }



    



    public void setSource(ImageSource source) {



        this.source1 = source;



    }



    



}



