/*



 * smoothFilter.java



 *



 * Created on 27 de abril de 2002, 09:05 AM



 */







package cannes.Imaging.ops;







/**



 *



 * @author  Rodolfo Cartas, rodolfocartas@ieee.org



 */







import javax.media.jai.*;



import java.awt.image.renderable.*;







/** Filtra una imagen mediante operaciones de convolucion */



public class convolFilter implements ImageSource {



    



    private PlanarImage     image;



    private PlanarImage     bImage;



    private KernelJAI       kern;



    private ImageSource     imageSource;



        



    /** Crea una nueva instancia convolFilter filtrando la imagen image*/



    public convolFilter(PlanarImage image, KernelConstructor kernelc) {



        



        this.kern = kernelc.getKernel();



        this.setImage( image );



        



    }



    



    public convolFilter(ImageSource source, KernelConstructor kernelc) {



        



        this.kern = kernelc.getKernel();



        this.setSource( source );



        this.setImage( this.imageSource.getImage() );



    }



       



    /** Hace el filtrado de la imagen */



    private void doFiltering() {



        //System.out.println("Limpiando Imagen");



        



        if( this.kern != null ) {



            ParameterBlock pb = new ParameterBlock();



            pb.addSource( this.image );



            pb.add( this.kern );



            this.bImage = JAI.create("convolve", pb, null);



        }



        else



            this.bImage = this.image;



        



    }



    



    /** Obtiene la imagen del objeto  */



    public PlanarImage getImage() {



        



        return this.bImage;



        



    }



    



    public void setImage(PlanarImage image) {



        



        this.image = image;



        this.doFiltering();



        



    }



    



    public ImageSource getSource() {



        return this.imageSource;



    }    



    



    public void reload() {



        this.setImage(this.imageSource.getImage());



    }    



        



    public void setSource(ImageSource source) {



        this.imageSource = source;



    }



    



}



    



    



