/*
 
 
 * hsvFilter.java
 
 
 *
 
 
 * Created on 26 de abril de 2002, 10:00 PM
 
 
 */





package cannes.Imaging.ops;





/**
 *
 *
 *
 *
 *
 * @author  Rodolfo Cartas, rodolfocartas@ieee.org
 *
 *
 */





import java.awt.*;


import java.awt.image.*;


import cannes.Imaging.ColorModel.*;


import javax.media.jai.*;





/**Filtra la imagen dejando solo los colores rojo y verde */


public class hsvFilter extends Component implements ImageSource{
    
    
    
    
    
    private PlanarImage         image;
    
    
    private Image               newImage;
    
    
    
    
    
    private Raster              raster;
    
    
    
    
    
    private ImageSource         imageSource;
    
    
    
    
    
    
    
    
    /** Crea una nueva instancia hsvFilter filtrando la imagen image*/
    
    
    public hsvFilter(PlanarImage image) {
        
        
        this.setImage(image);
        
        
    }
    
    
    
    
    
    public hsvFilter(ImageSource source) {
        
        
        this.setSource(source);
        
        
        this.setImage(this.imageSource.getImage());
        
        
    }
    
    
    
    
    
    /** Devuelve la imagen filtrada */
    
    
    public PlanarImage getImage() {
        
        
        return this.image;
        
        
    }
    
    
    
    
    
    public void setImage(PlanarImage image) {
        
        
        this.image = image;
        
        
        this.raster = image.getAsBufferedImage().getRaster();
        
        
        
        
        
        this.doFiltering();
        
        
    }
    
    
    
    
    
    /** Filtra la imagen */
    
    
    private void doFiltering() {
        
        
        BufferedImage       bImage;
        
        
        
        
        
        int     h = this.raster.getHeight();
        
        
        int     w = this.raster.getWidth();
        
        
        int     index = 0;
        
        
        int[]   filteredImage = new int[ h * w ];
        
        
        int     r = (new Color(255,0,0)).getRGB();
        
        
        int     g = (new Color(0,255,0)).getRGB();
        
        
        int     b = (new Color(0,0,255)).getRGB();
        
        
        int     els = (new Color(255,255,255)).getRGB();
        
        
        
        
        
        for( int y = 0; y < h; y++ )
            
            
            for( int x = 0; x < w; x++ ) {
                
                
                int c = this.queryColor(x,y,this.raster);
                
                
                switch( c ) {
                    
                    
                    case 0:
                        
                        
                        filteredImage[index] = r;
                        
                        
                        break;
                        
                        
                    case 1:
                        
                        
                        filteredImage[index] = g;
                        
                        
                        break;
                        
                        
                    case 2:
                        
                        
                        filteredImage[index] = b;
                        
                        
                        break;
                        
                        
                    default:
                        
                        
                        filteredImage[index] = els;
                        
                        
                        break;
                        
                        
                }
                
                
                index++;
                
                
            }
        
        
        
        
        
        this.newImage =
        
        
        createImage(new MemoryImageSource(w, h, filteredImage, 0, w));
        
        
        this.image=JAI.create("awtimage",newImage);
        
        
        
        
        
        //System.out.println( this.newImage.getHeight(null) );
        
        
    }
    
    
    
    
    
    /**Devuelve el tipo de color de acuerdo al valor HSV*/
    
    
    private static int queryColor(int x, int y, Raster raster){
        
        
        int[] q = {0,0,0};
        
        
        hsvElement hsv;
        
        
        
        
        
        q = raster.getPixel(x, y, q);
        
        
        hsv = new hsvElement( new rgbElement(q[0],q[1],q[2]) );
        
        
        
        
        
        if( hsv.getElement( hsvElement.hsvHue ) != -1 )
            
            
            if( hsv.getElement( 1 ) >= 0.4 && hsv.getElement( 2 ) >= 0.2  &&  (hsv.getElement(0)<=20 || hsv.getElement(0)>=340)) //ROJO
                
                
                return 0;
        
        
            else
                
                
                if(hsv.getElement( 1 ) >= 0.33 && (hsv.getElement(0)>=95 && hsv.getElement(0)<=145)) //VERDE
                    
                    
                    return 1;
        
        
                else
                    
                    
                    if(hsv.getElement( 1 ) >= 0.3 && hsv.getElement( 2 ) >= 0.3 && (hsv.getElement(0)>=210 && hsv.getElement(0)<=260)) //AZUL
                        
                        
                        return 2;
        
        
                    else
                        
                        
                        return -1;
        
        
        return -1;
        
        
    }
    
    
    
    
    
    public ImageSource getSource() {
        
        
        return this.imageSource;
        
        
    }
    
    
    
    
    
    public void reload() {
        
        
        this.setImage(this.imageSource.getImage());
        
        
    }
    
    
    
    
    
    public void setSource(ImageSource source) {
        
        
        this.imageSource = source;
        
        
    }
    
    
    
    
    
}


